// Header File
// Created 7/14/2004; 11:35:11 AM

#define DEBUG															FALSE
//#define DEBUG															TRUE
#define FLASE															FALSE //Counter typo...

//define concerning the gameplay:
#define SICK_TIME													500
#define EXPLOSION_TIME										27
#define DELAY															5
//#define concering the programming:
#define MAX_NUM_OF_BOMB 									34
#define PERSO_SPRITE_BYTE_WIDTH						2
#define	PERSO_SPRITE_HEIGHT								22
#define DYING_PERSO_BYTE_WIDTH						3
#define DYING_PERSO_HEIGHT								24
#define BUFFER_SIZE 											7200
#define LEVEL_HEIGHT											15
#define LEVEL_WIDTH												11
#define CHANCE_TO_BE_A_SOFT_BLOCK					(random(100)>15) // (=~85% chance...)
#define convertx(x)												(x<<4)
#define converty(y)												(y<<4)
#define NUM_OF_INTERSTEP									6
#define NUM_OF_STEP												4
#define MOVE_VECTOR												2
#define MAGIC_NUM													3494
#define MAGIC_NUM_CUSTOM									7897
#define QUIT        			13

enum editor_menu {NOTHING,SAVE,LOAD,BACKGROUND,BLOCK,SPAWN,PREVIEW,HELP,EXIT};

enum mplayer {HOST_NUMBER,JOIN_NUMBER};

enum directions {DIR_RIGHT,DIR_DOWN,DIR_LEFT,DIR_UP};
enum bomb {nothing,yes_bomb};

enum buffer_name	{LIGHT1,DARK1,LIGHT2,DARK2};
enum maps_name {m_static_tile,m_animated_tile,m_time,m_solid,m_trans,M_DANGER_AI};

#define NUMBER_OF_LEVEL 10
enum level_name {l_classic,l_teletransport,l_power,l_igloo,l_fith,l_EJC,l_SPACE,l_BEACH,l_DARI,l_CUSTOM};
enum status_tile {s_bomb,s_power,s_inter1,s_inter2,s_bdude_l,s_bdude_d,s_bdude_color};
enum danger_lev {d_none,d_medium,d_high};
enum game_result {g_win,g_loss,g_draw};
enum pref_enuma {map_num,ennemi_num,round_num,bonus_num,link_mode,rand_pos,rand_map,falling_block};

#define number_of_illness	7

enum sickness {
							si_not_sick,//0
							si_ultraspeed,
							si_slow,
							si_dairrhea,
							si_reverse,
							si_constipation,//5
							si_hyperactivity,//6
							si_lethargy};//7


#define number_of_bonus 7


enum animated_tile_name {
	bomb_small,
	bomb_large,
	nuage1,nuage2,nuage3,nuage4,

	h_1,h_2,h_3,h_4,h_5,h_6,
	v_1,v_2,v_3,v_4,v_5,v_6,
	c_1,c_2,c_3,c_4,c_5,c_6,//24
	hl_1,hl_2,hl_3,hl_4,hl_5,hl_6,
	hr_1,hr_2,hr_3,hr_4,hr_5,hr_6,
	vu_1,vu_2,vu_3,vu_4,vu_5,vu_6,
	vd_1,vd_2,vd_3,vd_4,vd_5,vd_6,
	h_explo_1,h_explo_2,h_explo_3,h_explo_4,//52
	space_explo_1,space_explo_2,space_explo_3,space_explo_4,
	exploding_cube1,exploding_cube2,exploding_cube3,exploding_cube4,
	exploding_snow1,exploding_snow2,exploding_snow3,exploding_snow4,
	rotating_block_1,rotating_block_2,rotating_block_3,rotating_block_4,
	trans_1,trans_2,trans_3,trans_4,trans_5,trans_6,
	rotating_block_xplo_1,rotating_block_xplo_2,rotating_block_xplo_3,rotating_block_xplo_4,//26
	//water1,water2,water3,water4,
	bonus1,bonus1b,//Tete de mort
	bonus2,bonus2b,//Flame
	bonus3,bonus3b,//Bombes
	bonus4,bonus4b,//Lignes
	bonus5,bonus5b,//Ghost
	bonus6,bonus6b,//Teletransporter
	bonus7,bonus7b//mines
	//bonus6,bonus6b,//Gant

	};

//Debug
//#define bonus7 bonus6
//#define bonus7b bonus6b

enum tile_name {
	igloo_LU,
	igloo_LM,
	igloo_LD,
	igloo_RU,
	igloo_RM,	
	igloo_RD,
	carelage_triangle,
	quasi_pyramide,
	quatre_cubes,
	cratere_lunaire,
	carelage,
	parelelipipede,
	round_block,
	sol_blanc,
	sol_alternate_blanc,
	sol_lunaire_1,
	sol_lunaire_2,
	sol_lunaire_3,
	sol_lunaire_4,
	sol_plage,
	hard_tile_plage,
	sol_alternate_plage,
	border_UR,
	border_U,
	border_UL,
	border_L,
	border_DL,
	border_D,
	border_DR,
	border_R,
	classic_gound,
	h_zarb,
	EJC_hard,
	EJC_soft,
	water,
	sol_snow,
	sol_snow_2,
	hard_snow,
	soft_snow,
	blockito2,
	blockito1,
	big_blockito,
	blockito_h,
	blockito_v,
	blockito_c,
	blockito_o,
	transporter,
	snow_g_1,
	snow_g_2,	
	snow_g_3,	
	snow_g_shadow,
	EJC_ground,
	custom1,
	custom2,
	custom3,
	space_soft,
	space_soft2,
	space_hard,
	space_center,
	space_vert,
	space_hori,
	space_empty,
	statue1,statue2,
	border1,border2,border3,border4,border5,border6,border7,
	crystal, panel, tree,
	ground1,ground2,ground3
};

