// Header File
// Created 8/7/2004; 4:30:07 PM


typedef struct {
    unsigned char 	x,y;								//Transfered
    short 	dir;
    short 	interstep;
    short 	step;
    short 	number_of_bomb;
    short 	number_of_bomb_left;
    short 	power;
		short 	has_put_a_bomb;							//Transfered
		short	 	has_hit_the_bonus_key;			//Transfered
    char	 	can_put_line;
    char 		can_teletransport;
    char		can_explode_all;
    short 	time_till_explosion;
    short 	is_a_ghost;
    short 	time_ghost;
    short 	sick;
    short 	sick_time;
    short 	quit;												//Transfered
    short 	is_drawn;
    short 	is_playing;
    short 	is_dying;
    short		death_frame;
    short 	num_of_vic;
    short   is_being_teletransported;
    short   t_frame;
    short   t_x;
    short   t_y;

    short variable_a_la_con_qui_sert_a_rien[7];//	<- WTF ???
}PLAYA;

typedef struct {
	char row;//Using "char" instead of "short" makes the non compressed program smaller, but makes the ppg bigger.
	char col;
}KEY;

typedef struct {
	short goal_x;
	short goal_y;
	short old_goal_x;
	short old_goal_y;
	short on;
}AI;


typedef struct {
    short on;
    short x,y;
    short time;
    short size;
    short player;
    short already_processed; //used in the loop to calculate if a bomb is dangerous
}BOMB;

typedef struct {
    unsigned char x,y;
    unsigned char flag;//bit 1->quit;bit 2->player has put a bomb;bit 3->player has git the bonus key;bit 4,5 -> direction; bit 6,7 -> step
}DATA_TRANSFERED;

typedef struct {
	char map[15][11];
	char preview[10];
	short hard_block;
	short soft_block;
	short exploding_block;
	char transporter_coord[16];
	short spawn_x[4];
	short spawn_y[4];
}LEVEL;

typedef struct {
	short prefs[8];
	//enum pref_enum {ennemi_num,link_mode,map_num,round_num,rand_pos,rand_map,bomb_limit,falling_block}
	short random_seed;	
	short magic;
	short bomberdude_version;
}PREF_STRUCT;


typedef struct {
	unsigned short size;
	unsigned short Magic;		
	LEVEL lvvl;
	unsigned char Tag[6];
}SAVE_STRUCT;

typedef struct {
	PREF_STRUCT preff;
	LEVEL lvll;
} TRANSFERED_PREF_STRUCT;